using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
	    public static void Main()
         {
        	   CategoryBuilder.Create("RRP", "RRP mod category", ModAPI.LoadSprite("icon.png"));

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "Common Soldier",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "1",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/Soldier.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/Soldier.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "SpetsNaz",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "2",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/SpetsNaz.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/SpetsNaz.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "OMON",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "3",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/Omon.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/Omon.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "Traffic Police",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "4",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/TrafficPolice.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/TrafficPolice.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "Police",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "5",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/Police.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/Police.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
	    OriginalItem = ModAPI.FindSpawnable("Human"),
	    NameOverride = "Military Police",
	    DescriptionOverride = " ",
	    CategoryOverride = ModAPI.FindCategory("RRP"),
	    NameToOrderByOverride = "6",
	    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/MilitaryPolice.png"),
	    AfterSpawn = (Instance) =>

	    {

	       var skin = ModAPI.LoadTexture("Sprites/Skins/MilitaryPolice.png");
	       var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
	       var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
	       var person = Instance.GetComponent<PersonBehaviour>();

	       person.SetBodyTextures(skin, flesh, bone, 1);

	       person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

	    }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "FSB",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "7",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/FSB.png"),
        AfterSpawn = (Instance) =>

        {

           var skin = ModAPI.LoadTexture("Sprites/Skins/FSB.png");
           var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
           var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
           var person = Instance.GetComponent<PersonBehaviour>();

           person.SetBodyTextures(skin, flesh, bone, 1);

           person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "FSO",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "8",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Skins/FSO.png"),
        AfterSpawn = (Instance) =>

        {

           var skin = ModAPI.LoadTexture("Sprites/Skins/FSO.png");
           var flesh = ModAPI.LoadTexture("Sprites/Skins/Flesh.png");
           var bone = ModAPI.LoadTexture("Sprites/Skins/Bone.png");
           var person = Instance.GetComponent<PersonBehaviour>();

           person.SetBodyTextures(skin, flesh, bone, 1);

           person.SetBruiseColor(67, 65, 65);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(64, 64, 64);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
        NameOverride = "AK-74M",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "!",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/AK74M.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0100Slide = Instance.transform.Find("Slide");

        AK0100Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AK74M/bolt.png", 3.5f);
        AK0100Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AK74M/part.png", 3.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.8f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.5f;
        firearm.casingPosition = new Vector3(0f,0.1f);

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/AK74M/ak74m.png", 3.5f);
        childSprite.sortingLayerName = "Default";
                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }

        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {

        ModAPI.LoadSound("Sounds/AK74M/AK.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5800f, 0.1400f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
        NameOverride = "AKS-74",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "@",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/AKS74.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0100Slide = Instance.transform.Find("Slide");

        AK0100Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74/bolt.png", 3.5f);
        AK0100Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74/part.png", 3.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.8f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.5f;
        firearm.casingPosition = new Vector3(0f,0.1f);

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74/aks74.png", 3.5f);
        childSprite.sortingLayerName = "Default";
                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }

        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {

        ModAPI.LoadSound("Sounds/AKS74/AK.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5800f, 0.1400f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
        NameOverride = "AKS-74U",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "#",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/AKS74U.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0100Slide = Instance.transform.Find("Slide");

        AK0100Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74U/bolt.png", 3.5f);
        AK0100Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74U/part.png", 3.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.8f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.5f;
        firearm.casingPosition = new Vector3(0f,0.1f);

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/AKS74U/aks74u.png", 3.5f);
        childSprite.sortingLayerName = "Default";
                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }

        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {

        ModAPI.LoadSound("Sounds/AKS74U/AK.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5800f, 0.1400f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
        NameOverride = "AS VAL",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "$",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/ASVAL.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0100Slide = Instance.transform.Find("Slide");

        AK0100Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/ASVAL/bolt.png", 3.5f);
        AK0100Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/ASVAL/part.png", 3.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.8f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.5f;
        firearm.casingPosition = new Vector3(0f,0.1f);

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/ASVAL/asval.png", 3.5f);
        childSprite.sortingLayerName = "Default";
                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }

        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {

        ModAPI.LoadSound("Sounds/ASVAL/ASVAL.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.5800f, 0.1400f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;

        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("Pistol"),
        NameOverride = "Makarov",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "%",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/PM.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0000Slide = Instance.transform.Find("Slide");

        AK0000Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Makarov/slide.png", 6.5f);
        AK0000Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Makarov/part.png", 6.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");                      
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.4f;
        customCartridge.StartSpeed *= 1f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.1f;
        firearm.casingPosition = new Vector3(-0.01f,0.1f); 

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/Makarov/PM.png", 6.5f);
        childSprite.sortingLayerName = "Default";                               
                                                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }
                        
        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {
                            
        ModAPI.LoadSound("Sounds/Makarov/Pistol.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.1000f, 0.1000f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = false;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
        
        }
    }
);

ModAPI.Register(
     new Modification()
     {
        OriginalItem = ModAPI.FindSpawnable("Pistol"),
        NameOverride = "APS",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        NameToOrderByOverride = "^",
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/APS.png"),
        AfterSpawn = (Instance) =>

        {

            ModAPI.KeepExtraObjects();
                        
    var AK0000Slide = Instance.transform.Find("Slide");

        AK0000Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/APS/slide.png", 6.5f);
        AK0000Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/APS/part.png", 6.5f);
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
                        
    var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");                      
        firearm.Cartridge = customCartridge;
        customCartridge.name = "cartridge";
        customCartridge.Damage *= 0.4f;
        customCartridge.StartSpeed *= 1f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0f;
        customCartridge.Recoil *= 0.5f;
        customCartridge.ImpactForce *= 0.1f;
        firearm.casingPosition = new Vector3(-0.01f,0.1f); 

    var childObject = new GameObject("ChildObject");

        childObject.transform.SetParent(Instance.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.rotation = Instance.transform.rotation;
        childObject.transform.localScale = new Vector3(1f, 1f);

    var childSprite = childObject.AddComponent<SpriteRenderer>();

        childSprite.sprite = ModAPI.LoadSprite("Sprites/Weapons/APS/APS.png", 6.5f);
        childSprite.sortingLayerName = "Default";                               
                                                        
        foreach (var c in Instance.GetComponents<Collider2D>())

            {
                GameObject.Destroy(c);
            }
                        
        Instance.AddComponent<BoxCollider2D>();
        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();

        firearm.ShotSounds = new AudioClip[]
    {
                            
        ModAPI.LoadSound("Sounds/APS/Pistol.mp3"),

    }

    ;Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.1000f, 0.1000f);
        Instance.GetComponent<FirearmBehaviour>().Automatic = false;
        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
        
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Military Helmet",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/MilitaryHelmet.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/MilitaryHelmet.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/MilitaryHelmet.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 40f;
            armor.armorPiece = "Head";
            armor.armorTier = 13;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "SpetsNaz Helmet",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/SpetsNazHelmet.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/SpetsNazHelmet.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/SpetsNazHelmet.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 40f;
            armor.armorPiece = "Head";
            armor.armorTier = 13;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "FSB Helmet",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/FSBHelmet.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/FSBHelmet.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/FSBHelmet.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 40f;
            armor.armorPiece = "Head";
            armor.armorTier = 13;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Altin Helmet",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/AltinHelmet.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/AltinHelmet.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/AltinHelmet.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 40f;
            armor.armorPiece = "Head";
            armor.armorTier = 13;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Omon Helmet",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/OmonHelmet.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/OmonHelmet.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/OmonHelmet.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 40f;
            armor.armorPiece = "Head";
            armor.armorTier = 13;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Traffic Police Cap",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/TrafficPoliceCap.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/TrafficPoliceCap.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/TrafficPoliceCap.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 0f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Police Cap",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/PoliceCap.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/PoliceCap.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/PoliceCap.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 0f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Red Beret",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/RedBeret.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/RedBeret.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/RedBeret.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 0f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Black Beret",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Helmets/BlackBeret.png"),
        AfterSpawn = (Instance) =>

        {
            Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/BlackBeret.png", 1f);
            Instance.FixColliders();


            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Helmets/BlackBeret.png", 1f);
            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

            armor.stabResistance = 0f;
            armor.armorPiece = "Head";
            armor.armorTier = 0;

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Police Baton",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/PoliceBaton.png", 1f),
        AfterSpawn = (generatorInstance) =>

        {
            generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/PoliceBaton/PoliceBaton.png", 1f);

         }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Traffic Police Baton",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Weapons/TrafficPoliceBaton.png", 1f),
        AfterSpawn = (generatorInstance) =>

        {
            generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/TPoliceBaton/TrafficPoliceBaton.png", 1f);

         }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
        NameOverride = "RGD 5",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Grenades/RGD5.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Grenades/RGD5.png");
            Instance.FixColliders();
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
        NameOverride = "F 1",
        DescriptionOverride = " ",
        CategoryOverride = ModAPI.FindCategory("RRP"),
        ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Grenades/F1.png"),
        AfterSpawn = (Instance) =>
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Grenades/F1.png");
            Instance.FixColliders();
        }
    }
);
	    }
    }
}